------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
private with Ada.Finalization;
with Interfaces.C;
with System;

private with Qt_Ada.Internals.Value_Class_Sizes;

package Qt4.Text_Lengths is

   --  QTextLength::Type

   type Text_Length_Type is
    (Variable_Length,
     Fixed_Length,
     Percentage_Length);
   pragma Convention (C, Text_Length_Type);
   for Text_Length_Type'Size use Interfaces.C.unsigned'Size;

   type Q_Text_Length is tagged private;

   function Create
    (Length_Type : Text_Length_Type;
     Value : Qt4.Q_Real)
       return Q_Text_Length;

   function Raw_Value
    (Self : Q_Text_Length'Class)
       return Qt4.Q_Real;

   function Length_Type
    (Self : Q_Text_Length'Class)
       return Text_Length_Type;

   function Value
    (Self : Q_Text_Length'Class;
     Maximum_Length : Qt4.Q_Real)
       return Qt4.Q_Real;

   overriding function "="
    (Self : Q_Text_Length;
     Other : Q_Text_Length)
       return Boolean;

   package Internals is

      type QTextLength is private;

      type QTextLength_Access is access all QTextLength;
      pragma Convention (C, QTextLength_Access);

      function QTextLength_View
       (Item : Q_Text_Length'Class)
          return QTextLength_Access;
      pragma Inline (QTextLength_View);

      function To_Pointer
       (Address : System.Address)
          return QTextLength_Access;
      pragma Inline (To_Pointer);

      function To_Address
       (Pointer : QTextLength_Access)
          return System.Address;
      pragma Inline (To_Address);

      function Create_Wrapper
       (Item : Internals.QTextLength_Access)
          return Q_Text_Length;

   private

      type QTextLength is record
         Placeholder : Interfaces.C.char_array (1 .. Qt_Ada.Internals.Value_Class_Sizes.QTextLength_C_Size_Of);
      end record;
      pragma Convention (C, QTextLength);

   end Internals;

private

   type Q_Text_Length is new Ada.Finalization.Controlled with record
      Storage : aliased Internals.QTextLength;
      Object  : Internals.QTextLength_Access := null;
      Wrapper : Boolean := False;
   end record;

   overriding
   procedure Adjust (Self : in out Q_Text_Length);

   overriding
   procedure Finalize (Self : in out Q_Text_Length);

   overriding
   procedure Initialize (Self : in out Q_Text_Length);

end Qt4.Text_Lengths;
